if (document.readyState !== 'loading') {
    load();
}
else {
    document.addEventListener("DOMContentLoaded", function () {
        load();
    });
}
function uuid() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
}
var _triggerId = "";
var _triggerURI = "";
var _uuid = uuid();
var _ip = "";
function load() {
    Survey.StylesManager.applyTheme("defaultV2");
    loadAppSettings();
    var args = new URLSearchParams(window.location.search);
    if (args.has("triggerid")) {
        _triggerId = args.get("triggerid");
        loadTriggerDefinition(_triggerId);
    }
    else {
        display("No trigger parameter found.");
    }
    getIP().then(function (ip) { return _ip = ip; });
    function display(msg) {
        document.querySelector("#surveyResults").textContent = msg;
        document.querySelector("#resultsContainer").style.display = "block";
    }
    function getIP() {
        return fetch('https://api.ipify.org/?format=json', { method: "GET" })
            .then(function (r) { return r.json(); })
            .then(function (r) { return r.ip; });
    }
    function toDictionary(data, flattenArrays) {
        if (flattenArrays === void 0) { flattenArrays = true; }
        var dictionary = {};
        var keys = Object.keys(data);
        for (var i = 0; i < keys.length; i++) {
            var key = keys[i];
            var value = data[key];
            if (typeof value === "string") {
                dictionary[key] = value;
            }
            else {
                if (Array.isArray(value) && flattenArrays) {
                    dictionary[key] = value.join(',');
                }
                else {
                    dictionary[key] = JSON.stringify(value);
                }
            }
        }
        return dictionary;
    }
    function onSurveyComplete(sender) {
        grecaptcha.ready(function () {
            grecaptcha.execute('6LfF8_siAAAAAORRCK2qIsmXXjfwnhutUnsmekOP', { action: 'Register' })
                .then(function (recaptchaResult) {
                var browserInfo = {
                    appCodeName: navigator["appCodeName"],
                    appName: navigator["appName"],
                    appMinorVersion: navigator["appMinorVersion"],
                    cpuClass: navigator["cpuClass"],
                    platform: navigator["platform"],
                    opsProfile: navigator["opsProfile"],
                    userProfile: navigator["userProfile"],
                    systemLanguage: navigator["systemLanguage"],
                    userLanguage: navigator["userLanguage"],
                    appVersion: navigator["appVersion"],
                    userAgent: navigator["userAgent"],
                    onLine: navigator["onLine"],
                    cookieEnabled: navigator["cookieEnabled"]
                };
                var result = {
                    IP: _ip,
                    TriggerId: _triggerId,
                    Referrer: document.referrer,
                    UUID: _uuid,
                    BrowserInfo: toDictionary(browserInfo, false),
                    FormData: toDictionary(sender.data)
                };
                tx(recaptchaResult, result)
                    .catch(function (err) {
                    display("Could not submit form.");
                    console.error(err);
                });
            }, function (err) { return alert(err); });
        });
    }
    function tx(recaptcha, result) {
        var data = {
            TriggerId: _triggerId,
            Recaptcha: recaptcha,
            Result: result
        };
        var jsonData = JSON.stringify(data);
        return fetch(_triggerURI, {
            method: 'POST',
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            },
            body: jsonData,
            cache: 'default'
        });
    }
    function loadAppSettings() {
        return fetch("app.json?v=1")
            .then(function (r) { return r.json(); })
            .then(function (settings) {
            _triggerURI = settings.DefaultTriggerURI;
            document.title = settings.DefaultTitle;
        });
    }
    function loadTriggerDefinition(triggerId) {
        fetch("triggers/" + triggerId + ".json")
            .then(function (response) {
            return response.json();
        })
            .then(function (triggerDefinition) {
            if (triggerDefinition && triggerDefinition.Active) {
                var survey = new Survey.Model(triggerDefinition.SurveyConfiguration);
                if (survey.title) {
                    document.title = survey.title;
                }
                survey.onComplete.add(onSurveyComplete);
                survey.render("surveyContainer");
            }
            else {
                display('Trigger is not currently available.');
            }
        })
            .catch(function (err) {
            display("No trigger found with id: " + triggerId);
        });
    }
}
//# sourceMappingURL=index.js.map